                     MEMBER('testlegacy.clw')

HoldPosition         STRING(512),THREAD


!--------------------------------------------------
RISnap:pli          PROCEDURE
  CODE

!--------------------------------------------------
RIUpdate:pli         FUNCTION(BYTE FromForm)
  CODE
  LOGOUT(2,pli)
  IF ERRORCODE()
    RISaveError
    StandardWarning(Warn:LogoutError,'Update','pli')
    DO RICloseFiles
    RETURN(1)
  END
  HoldPosition = POSITION(pli)
  PUT(pli)
  IF ERRORCODE()
    RISaveError
    IF SaveErrorCode = RecordChangedErr THEN
      IF FromForm THEN
        StandardWarning(Warn:RIFormUpdateError)
      ELSE
        StandardWarning(Warn:RIUpdateError,'Record Changed by Another Station')
      END
      WATCH(pli)
      REGET(pli,HoldPosition)
      DO RICloseFiles
      RETURN(2)
    ELSE
      StandardWarning(Warn:RIUpdateError,'pli')
      DO RICloseFiles
      RETURN(1)
    END
  END
  COMMIT
  DO RICloseFiles
  RETURN(0)
!----------------------------------------------------------------------
RICloseFiles ROUTINE
!|
!| This routine is called to close any files opened durint RI processing
!|
  EXIT

!--------------------------------------------------
RISnap:test         PROCEDURE
  CODE

!--------------------------------------------------
RIUpdate:test        FUNCTION(BYTE FromForm)
  CODE
  LOGOUT(2,test)
  IF ERRORCODE()
    RISaveError
    StandardWarning(Warn:LogoutError,'Update','test')
    DO RICloseFiles
    RETURN(1)
  END
  HoldPosition = POSITION(test)
  PUT(test)
  IF ERRORCODE()
    RISaveError
    IF SaveErrorCode = RecordChangedErr THEN
      IF FromForm THEN
        StandardWarning(Warn:RIFormUpdateError)
      ELSE
        StandardWarning(Warn:RIUpdateError,'Record Changed by Another Station')
      END
      WATCH(test)
      REGET(test,HoldPosition)
      DO RICloseFiles
      RETURN(2)
    ELSE
      StandardWarning(Warn:RIUpdateError,'test')
      DO RICloseFiles
      RETURN(1)
    END
  END
  COMMIT
  DO RICloseFiles
  RETURN(0)
!----------------------------------------------------------------------
RICloseFiles ROUTINE
!|
!| This routine is called to close any files opened durint RI processing
!|
  EXIT
